#include <pspkernel.h>
#include <psppower.h>
#include "tri/triImage.h"
#include "tri/triGraphics.h"
#include "tri/triTypes.h"
#include "tri/triLog.h"
#include "tri/triMemory.h"
#include "tri/triFont.h"
#include "tri/triInput.h"
#include <fitz.h>
#include <mupdf.h>
#include "dirent.h"

enum colors {
		RED =	0xFF0000FF,
		GREEN =	0xFF00FF00,
		BLUE =	0xFFFF0000,
		WHITE =	0xFFFFFFFF,
		LITEGRAY = 0xFFBFBFBF,
		GRAY =  0xFF7F7F7F,
		DARKGRAY = 0xFF3F3F3F,		
		BLACK = 0xFF000000,
	};

extern int isrunning;
extern void splash_screen(char *);
extern void file_chooser(void);
extern void render_pdf(void);
extern triFont *impact12;
extern triFont *impact16;
extern char src_pdf[128];
extern int cache_srv(SceSize args, void *argp);
extern void die(fz_error *eo);
extern void fz_printerror(fz_error *eo);
extern void printerror(fz_error *eo);
extern void maybedie(fz_error* eo);
extern SceUID msgbox;
extern char cachesrv_status;
extern fz_pixmap *current_pix;

typedef struct _MSG_
{
  SceKernelMsgPacket header;
  char               command;                        /* L = load, Z = zoom       */
  int                num_page;
  float              zoom;                                          
} MSG;

typedef struct _TABCACHE_
{
  int             num_page;
  float           zoom;
  fz_pixmap       *pix;
  fz_obj          *pageobj;
  pdf_page        *drawpage;
} TABCACHE;
