#include "psp_pdf.h"
triImage*    pix_bitmap;
SceUID       msgbox;
MSG          msg;
fz_pixmap    *current_pix;

static triS32 next_pow2(triU32 w)
{
  w -= 1;		// To not change already power of 2 values
  w |= (w >> 1);
  w |= (w >> 2);
  w |= (w >> 4);
  w |= (w >> 8);
  w |= (w >> 16);
  return(w+1);
}

static triS32 next_mul8(triU32 w)
{
  return((w+7)&~0x7);
}

void display_page( int page_courante,int pos_x,int pos_y)
{
   int y;

   unsigned char *ptr_dest;
	
   ptr_dest = pix_bitmap->data;
   if (cachesrv_status != 'W')        /* wait for ready or busy to draw current pix */
   {
     for(y=0;y<272;y++)
     {
       memcpy(ptr_dest,&current_pix->samples[ (pos_y+y)*current_pix->n*current_pix->w+pos_x*4 ],480*4);
       ptr_dest = ptr_dest+((pix_bitmap->stride)*(pix_bitmap->bits>>3));
     }
     triImageToVRAM( pix_bitmap );
     triDrawImage2(0.0f,0.0f,pix_bitmap);
     triSwapbuffers(); 
   }
}

void render_pdf(void)
{
  int     page_courante;
  int     old_page;
  float   zoom;
  int     x;
  int     y;
  int     tid;
  triVec2 *pStick;

  cachesrv_status = 'W';
  msgbox = sceKernelCreateMbx("cachesrv", 0, 0);
  page_courante = 1;
  zoom          = 1.4f;
  tid = sceKernelCreateThread( "cachesrv", 
                               cache_srv,                            
                               0x11,
                               128 * 1024,                          
                               PSP_THREAD_ATTR_USER,
                               0);
  sceKernelStartThread(tid, 0, NULL);
//
//  Allocate a bitmap 480x272 in RGBA format
//
  pix_bitmap = triMalloc(sizeof(triImage));

  pix_bitmap->level      = 0; 
  pix_bitmap->levels     = 0;
  pix_bitmap->swizzled   = 0;
  pix_bitmap->palette    = 0;
  pix_bitmap->level      = 0;
  pix_bitmap->palette    = 0;
  pix_bitmap->bits       = 32;
  pix_bitmap->format     = 3;
  pix_bitmap->width      = 480;
  pix_bitmap->height     = 272;
  pix_bitmap->tex_height = next_pow2(272);
  pix_bitmap->stride     = next_pow2(480) ;
  pix_bitmap->size       = pix_bitmap->stride*next_mul8(272)*(pix_bitmap->bits>>3);
  pix_bitmap->data       = triMalloc(pix_bitmap->size);
  memset(pix_bitmap->data,0xff,pix_bitmap->size); 

  triClear( 0x000000 );	  
  triSwapbuffers(); 
;
 
  old_page      = -1;
  x = 0;
  y = 0;

  msg.command   = 'L';
  msg.num_page  = 1;
  msg.zoom      = zoom;
  sceKernelSendMbx(msgbox, &msg );
  while ( isrunning )
  { 
    triInputUpdate ();
    pStick	= triInputGetStick ();

    if (triInputHeld (PSP_CTRL_CROSS))
    {
       isrunning = 0;
    }

    if (triInputHeld (PSP_CTRL_LTRIGGER) )
    {
      zoom -= 0.1 ;
      msg.command   = 'Z';
      msg.num_page  = page_courante;
      msg.zoom      = zoom;
      sceKernelSendMbx(msgbox, &msg );
    }

    if (triInputHeld (PSP_CTRL_RTRIGGER) )
    {
      zoom += 0.1 ;
      msg.command   = 'Z';
      msg.num_page  = page_courante;
      msg.zoom      = zoom;
      sceKernelSendMbx(msgbox, &msg );
    }

    if (triInputHeld (PSP_CTRL_LEFT) )
    {
      page_courante = 4;
      msg.command   = 'L';
      msg.num_page  = page_courante;
      msg.zoom      = zoom;
     sceKernelSendMbx(msgbox, &msg );
    }
      
    if (triInputHeld (PSP_CTRL_RIGHT) )
    {
      page_courante = 2;
      msg.command   = 'L';
      msg.num_page  = page_courante;
      msg.zoom      = zoom;
     sceKernelSendMbx(msgbox, &msg );
    }
     
    if (pStick->x < 0)
      {
        x-=16;
        if (x<0)
          x = 0;
      }
    if (pStick->x > 0)
      {
        x+=16;
        if (x> current_pix->w-480)
          x-=16;        
      }
    if (pStick->y < 0)
      {
        y-=8;
        if (y<0)
          y+=8;
      }
    if (pStick->y > 0)
      {
        y+=8;
        if (y>=current_pix->h-272)
          y -=8;
      }
    display_page( page_courante,x,y);  /* let the cache server handle the draw of the pix bitmap */
   
  }
  triFree( pix_bitmap->data );
  triFree( pix_bitmap);
}
