#include "psp_pdf.h"
char current_path[256];
LISTE *tete = NULL;

int is_pdf(char *filename)
{
   FILE          *fichin;
   unsigned char magic[4];

   fichin = fopen(filename,"r+b");
   fread(magic,1,4,fichin);
   fclose(fichin);
   return  (magic[0] == '%' &&
            magic[1] == 'P' &&
            magic[2] == 'D' &&
            magic[3] == 'F');
}

void messagebox(char *texte)
{
  while (isrunning)
  {
    triDrawRect( 130,136,strlen(texte)*8,20,WHITE);
    triFontActivate(impact16);
    triFontPrintf(impact16, 130+10 , 136+2 , RED,texte); 
    triSwapbuffers();
    triInputUpdate ();
    if (triInputPressed (PSP_CTRL_CROSS))      
    {
      sleep( 1 );
      return;
    }
  }
 
}
void get_list(void)
{
  DIR  *dir = NULL;
  int  i    = 0;
  LISTE *p = NULL;
  LISTE *q = NULL;
  struct dirent *entry;
  
  getcwd(current_path,sizeof(current_path));
  if (strcmp(current_path,"ms0:") == 0)
    strcat(current_path,"/");
  dir = opendir( current_path );
  if (dir == NULL)
    return;
  entry = readdir(dir);                    /* bypassing the . */
  while ((entry = readdir(dir)) != NULL)
  {
    if ( (i % MAX_FILE) == 0)
      {
          p = triMalloc( sizeof(LISTE) );
          p->droite      = NULL;
          p->gauche      = q;
          p->nbr_fichier = 0;
          if (tete == NULL)
               tete = p;
          else q->droite = p;
          q = p ; 
      }
    
    strcpy(p->tab_file[p->nbr_fichier].filename,entry->d_name); 
    memcpy(&p->tab_file[p->nbr_fichier].d_stat,
           &entry->d_stat,
           sizeof(SceIoStat));
    if (! (entry->d_stat.st_mode &  FIO_S_IFDIR))
      p->tab_file[p->nbr_fichier].is_pdf = is_pdf(p->tab_file[p->nbr_fichier].filename);
    
    p->nbr_fichier++;
    i++;
  }
 
  for(i=p->nbr_fichier;i<MAX_FILE;i++)
      sprintf(p->tab_file[i].filename,"test %d",i);

  closedir(dir);
}

void free_list(void)
{
   LISTE *p           = NULL;
   LISTE *q           = NULL;

   p = tete;
   while (p != NULL)
   {
     q = p->droite;
     triFree( p );
     p = q;
   }  
   tete = NULL;
}

void file_chooser(PARAM *app)
{
   int           i           = 0;
   int           courant     = 0;
   LISTE         *p;

   triImage      *back_pix = triImageLoad( "icon_back.png",0 );
   if (back_pix == 0)
   {
     triLogError("Error loading icon_back.png!\n");
     isrunning = 0;
     sceKernelExitGame(); 
   }

   triImage      *folder_pix = triImageLoad( "icon_folder.png",0 );
   if (folder_pix == 0)
   {
     triLogError("Error loading icon_folder.png!\n");
     isrunning = 0;
     sceKernelExitGame(); 
   }

   triImage      *pdf_pix = triImageLoad( "icon_pdf.png",0 );
   if (pdf_pix == 0)
   {
     triLogError("Error loading icon_pdf.png!\n");
     isrunning = 0;
     sceKernelExitGame(); 
   }

   get_list();
   p = tete;
   while (isrunning)
   {
     triClear( 0x000000 );

//     triDrawRect( 0, 0, 480,272,BLACK);
     triDrawRectGrad( 0, 0, 480, 272, 0xff000000,0x00ff0000,0x0000ff00,0x000000ff);
     triDrawRectOutline( 20, 20, 440, 232, WHITE );
     triDrawRectOutline( 430,25,20,222,WHITE); 
     triDrawRect( 432,27,17,20,GREEN);
     triFontActivate(impact16);
     triFontPrintf(impact16, 18 , 5 , GREEN,current_path); 
     for(i=0; i < p->nbr_fichier ; i++)
     {
        triFontActivate(impact16);
        if (i == courant)
             triFontPrintf(impact16,50,26+i*20,BLUE,"%-40s",p->tab_file[i].filename);
        else triFontPrintf(impact16,50,26+i*20,WHITE,"%-40s",p->tab_file[i].filename);

        if (p->tab_file[i].d_stat.st_mode & FIO_S_IFDIR)
          {
            if ( strcmp(p->tab_file[i].filename,"..") == 0)
                 triDrawImage2(25.0f,25.0f+i*20,back_pix);
            else triDrawImage2(25.0f,25.0f+i*20,folder_pix);
          }
        else if (p->tab_file[i].is_pdf)
               triDrawImage2(25.0f,25.0f+i*20,pdf_pix);   
     }

     triSwapbuffers();
     triInputUpdate ();
     if (triInputPressed (PSP_CTRL_CROSS))      
      {
        if (p->tab_file[courant].d_stat.st_mode &  FIO_S_IFDIR )
        {
           chdir( p->tab_file[courant].filename);
           free_list();
           courant = 0;
           get_list();
        }
        else {    
               if (p->tab_file[courant].is_pdf )
               {
                 strcpy(app->filename,p->tab_file[courant].filename);
                 free_list();
                 triImageFree( back_pix );
                 triImageFree( folder_pix );
                 triImageFree( pdf_pix );
                 return;
               }
               else messagebox("Not a PDF - Press X to continue");
             }
      }
      if (triInputPressed (PSP_CTRL_DOWN) )      
      {
         if (courant < p->nbr_fichier-1)
           courant++;
      }
      if (triInputPressed (PSP_CTRL_UP) )      
      {
         if (courant > 0)
          courant--;
      }
        
    }
   return;
}
