#include "psp_pdf.h"

PSP_MODULE_INFO("PSPPDF", PSP_MODULE_USER, 1, 1);
PSP_MAIN_THREAD_ATTR(PSP_THREAD_ATTR_USER|PSP_THREAD_ATTR_VFPU);
PSP_HEAP_SIZE_KB(-256);
;

int isrunning = 1;
triFont *impact12;
triFont *impact16;
PARAM    app;


int exit_callback(int arg1, int arg2, void *common) 
{
	isrunning = 0;
	return 0;
}

int CallbackThread(SceSize args, void *argp) 
{
	int cbid = sceKernelCreateCallback("Exit Callback", exit_callback, NULL);
	sceKernelRegisterExitCallback(cbid);
	sceKernelSleepThreadCB();
	return 0;
}

int SetupCallbacks(void) 
{
	int thid = sceKernelCreateThread("CallbackThread", CallbackThread, 0x11, 0xFA0, PSP_THREAD_ATTR_USER, 0);
	if (thid >= 0) sceKernelStartThread(thid, 0, 0);
	return thid;
}


int main() 
{
   scePowerSetClockFrequency(333, 333, 166);
   SetupCallbacks();

   triLogInit();
   triMemoryInit();
   triInit( GU_PSM_8888 );
   triFontInit();
   triInputInit();

   impact12 = triFontLoad("./arial.ttf", 12, TRI_FONT_SIZE_PIXELS, 128, TRI_FONT_VRAM);
   if (!impact12)
     {
       triLogError("Error loading font impact12.ttf!\n");
       isrunning = 0;
       sceKernelExitGame();
     }
   impact16 = triFontLoad("./arial.ttf", 16, TRI_FONT_SIZE_PIXELS, 128, TRI_FONT_VRAM);
   if (!impact16)
     {
       triLogError("Error loading font impact16.ttf!\n");
       isrunning = 0;
       sceKernelExitGame();
     }

   splash_screen("./logo.png");
   memset(&app, 0, sizeof(PARAM));
   file_chooser( &app );
   render_pdf();
   triFontUnload(impact12);
   triFontUnload(impact16);
   triFontShutdown();
   triClose();
   triMemoryCheck();
   triMemoryShutdown();
   sceKernelExitGame();
   return 0;
}
