#include <pspkernel.h>
#include <psppower.h>
#include "tri/triImage.h"
#include "tri/triGraphics.h"
#include "tri/triTypes.h"
#include "tri/triLog.h"
#include "tri/triMemory.h"
#include "tri/triFont.h"
#include "tri/triInput.h"
#include <fitz.h>
#include <mupdf.h>
#include "dirent.h"

enum colors {
		RED      = 0xFF0000FF,
		GREEN    = 0xFF00FF00,
		BLUE     = 0xFFFF0000,                     /* ARGB */
		WHITE    = 0xFFFFFFFF,
		LITEGRAY = 0xFFBFBFBF,
		GRAY     = 0xFF7F7F7F,
		DARKGRAY = 0xFF3F3F3F,		
		BLACK    = 0xFF000000,
                YELLOW   = 0xF00FFFFF
	};

typedef struct _PARAM_PSPPDF_
{
	/* current document params */
	char filename[32];
	char *doctitle;
	pdf_xref *xref;
	pdf_outline *outline;
	pdf_pagetree *pages;
	fz_renderer *rast;

	/* current view params */
	float zoom;
	int rotate;
	fz_pixmap *image;

	/* current page params */
	int pageno;
	pdf_page *page;
        int osd_timeout;
} PARAM;

struct __PARAM_FICHIER__
{
  char            filename[32]; 
  SceIoStat       d_stat;
  int             is_pdf;
};

#define MAX_FILE 12
typedef struct __LISTE__
{
  int                       nbr_fichier;
  struct __PARAM_FICHIER__  tab_file[MAX_FILE];
  struct __LISTE__          *droite;
  struct __LISTE__          *gauche;
} LISTE ;

extern PARAM app;

extern int isrunning;
extern void splash_screen(char *);
extern void file_chooser(PARAM *);
extern void render_pdf(void);
extern triFont *impact12;
extern triFont *impact16;
extern void psppdf_error(fz_error *eo);
extern void psppdf_warn(fz_error *eo);
extern fz_pixmap *current_pix;
