#include "psp_pdf.h"

void splash_screen(char * filename)
{
   char texte[] = "Press X to continue";
   int couleur[5] = { WHITE,BLUE,YELLOW,RED,GREEN };
   int flip = 0;
  
   triImage* splash = triImageLoad( filename,0 );
   if (splash == 0)
   {
     triLogError("Error loading %s!\n",filename);
     isrunning = 0;
     sceKernelExitGame(); 
   }
   triImageToVRAM( splash );
   while (isrunning)
   {
      triClear( 0x000000 );
      triDrawImage2(20.0f,20.0f,splash);
      triFontActivate(impact12);
  
      triFontPrint(impact12, 350, 220, couleur[flip/200], texte); 
      flip++;
      flip = flip % 1200;
      triFontPrint(impact12, 480,220,WHITE,".");
  
      triSwapbuffers();
      triInputUpdate ();
      if (triInputPressed (PSP_CTRL_CROSS))
        {       
           triImageFree( splash );  
           sleep(1);
           return;
        }
    }
    if (! isrunning)
      triImageFree( splash );   /* paranoia just for the statistics free memory if game is ended */
}
